/*
 * This software is distributed under following license based on modified BSD
 * style license.
 * ----------------------------------------------------------------------
 * 
 * Copyright 2003 The T-Struts Project. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE T-STRUTS PROJECT ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
 * NO EVENT SHALL THE T-STRUTS PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the T-Struts Project.
 */
package jp.ossc.tstruts.action.ejb.business;

import javax.ejb.EJBContext;

import jp.ossc.tstruts.action.ejb.BusinessException;
import jp.ossc.tstruts.action.ejb.BusinessSystemException;
import jp.ossc.tstruts.action.ejb.facade.BusinessGroup;
import jp.ossc.tstruts.common.InvocationContext;

/**
 * ƖC^tF[XB<p>
 * ƖNXFacadełƖO[vEJB {@link BusinessGroup}ɂăO[sOƖ̃C^tF[XłB
 * ƖNX̊J҂́ÃC^tF[X{@link BusinessBase}pTuNX邱ƁB
 * 
 * @version $Name: release-1_1-1_0 $
 * @author M.Takata
 * @since 1.0
 */
public interface Business{
    
    /**
     * O[sOĂƖO[vݒ肷B<p>
     *
     * @param group O[sOĂƖO[v
     * @see #getBusinessGroup()
     */
    public void setBusinessGroup(BusinessGroup parent);
    
    /**
     * O[sOĂƖO[v擾B<p>
     *
     * @return O[sOĂƖO[v
     * @see #setBusinessGroup(BusinessGroup)
     */
    public BusinessGroup getBusinessGroup();
    
    /**
     * O[sOĂƖO[vEJBContextݒ肷B<p>
     * 
     * @param context O[sOĂƖO[vEJBContextIuWFNg
     * @see #getEJBContext()
     */
    public void setEJBContext(EJBContext context);
    
    /**
     * O[sOĂƖO[vEJBContext擾B<p>
     * 
     * @return O[sOĂƖO[vEJBContextIuWFNg
     * @see #setEJBContext(EJBContext)
     */
    public EJBContext getEJBContext();
    
    /**
     * ƖsB<p>
     * 
     * @param context sɕKvȂ̂i[ReLXg
     * @return sʂi[ReLXg
     * @exception BusinessException ƖɗOꍇ
     */
    public InvocationContext work(InvocationContext context)
     throws BusinessException,BusinessSystemException;
}