/*
 * This software is distributed under following license based on modified BSD
 * style license.
 * ----------------------------------------------------------------------
 * 
 * Copyright 2003 The T-Struts Project. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE T-STRUTS PROJECT ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
 * NO EVENT SHALL THE T-STRUTS PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the T-Struts Project.
 */
package jp.ossc.tstruts.config;

/**
 * @version $Name: release-1_1-1_0 $
 * @author N.Kurosawa
 * @since 1.0
 */
public class JDBCInitializerMappingConfig {
	private String column = null;
	private String property = null;
	private UserProfilePropertyConfig associatedProperty = null;
	private boolean configured = false;
	
	/**
	 * NGʃZbg̃Jݒ
	 * @param string J
	 */
	public void setColumn(String string) {
		if (configured) {
			throw new IllegalStateException("Configuration is frozen");
		}
		column = string;
	}

	/**
	 * NGʃZbg̃J擾
	 * @return
	 */
	public String getColumn() {
		return column;
	}

	/**
	 * [Uvt@CNX̃tB[hݒ
	 * @param string tB[h
	 */
	public void setProperty(String string) {
		if (configured) {
			throw new IllegalStateException("Configuration is frozen");
		}
		property = string;
	}

	/**
	 * [Uvt@CNX̃tB[h擾
	 * @return
	 */
	public String getProperty() {
		return property;
	}

	/**
	 * ̃}bsO֘Atꂽڂ擾B
	 * @return
	 */
	public UserProfilePropertyConfig getAssociatedProperty() {
		return associatedProperty;
	}

	/**
	 * ̃}bsO֘Atꂽڂݒ肷B
	 * @param config
	 */
	public void setAssociatedProperty(UserProfilePropertyConfig config) {
		if (configured) {
			throw new IllegalStateException("Configuration is frozen");
		}
		associatedProperty = config;
	}

	public void freeze() {
		configured = true;
	}
}
