/*
 * This software is distributed under following license based on modified BSD
 * style license.
 * ----------------------------------------------------------------------
 * 
 * Copyright 2003 The T-Struts Project. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE T-STRUTS PROJECT ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
 * NO EVENT SHALL THE T-STRUTS PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the T-Struts Project.
 */
package jp.ossc.tstruts.config;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.ossc.tstruts.tiles.TileUtil;
import jp.ossc.tstruts.tiles.TilesServletRequest;
import jp.ossc.tstruts.tiles.TilesServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.Globals;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.upload.MultipartRequestWrapper;
import org.apache.struts.util.RequestUtils;

/**
 * ^CƂăANVʂ}邽߂putݒ 
 * @version $Name: release-1_1-1_0 $
 * @author H.Matsuno
 * @since 1.0
 */
public class TilePutActionConfig extends TilePutConfigBase {	
	private static final Log log = LogFactory.getLog(TilePutActionConfig.class);

	/* ( Javadoc)
	 * @see jp.ossc.tstruts.config.TilePutConfigBase#doRequest(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse, javax.servlet.ServletContext)
	 */
	protected String doRequest(HttpServletRequest request, HttpServletResponse response, ServletContext servletContext) throws ServletException, IOException {
		// ^OsAʕԂlƂ
		return createContent(request, response, servletContext);
	}

	/**
	 * createContentǂ݌p
	 * 
	 * @param putConfig
	 * @param request
	 * @param response
	 * @param context
	 * @return ^O
	 * @throws ServletException
	 * @throws IOException
	 */
	protected String createContent(HttpServletRequest request, HttpServletResponse response, ServletContext context) throws ServletException, IOException {
		// o̓f[^obt@O郌X|XIuWFNg쐬
		TilesServletResponse tilesResponse = new TilesServletResponse(response);

		// ݂̃W[EvtBNXۑ
		String modulePrefix = ((ActionMapping)request.getAttribute(Globals.MAPPING_KEY)).getModuleConfig().getPrefix();

		// sActionURI
		String uri = getValue();
		if (!uri.startsWith("/")) {
			// w肳ꂽURI̐擪"/"ȂꍇAW[΃pXƉ߂B
			StringBuffer s = new StringBuffer();
			if (modulePrefix != null) {
				s.append(modulePrefix);
			}
			s.append("/");
			s.append(uri);
			uri = s.toString();
		}
		if (log.isDebugEnabled()) {
			log.debug("Generate content uri:" + uri);
		}

		// Unwrap the multipart request, if there is one.
		if (request instanceof MultipartRequestWrapper) {
			request = ((MultipartRequestWrapper)request).getRequest();
		}

		// RequestDispatcher̎擾
		RequestDispatcher rd = context.getRequestDispatcher(uri);
		if (rd == null)
			return null;

		// TuNGXgEIuWFNg쐬
		TilesServletRequest tilesRequest = new TilesServletRequest(request);
		
		// NGXgp[^ݒ
		TileUtil.populate(context, request, tilesRequest, this);

		// TuNGXgs
		rd.include(tilesRequest, tilesResponse);

		// ۑĂW[EvtBNX𕜌
		RequestUtils.selectModule(modulePrefix, request, context);

		return tilesResponse.getContent();
	}
}
