/*
 * This software is distributed under following license based on modified BSD
 * style license.
 * ----------------------------------------------------------------------
 * 
 * Copyright 2003 The T-Struts Project. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE T-STRUTS PROJECT ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
 * NO EVENT SHALL THE T-STRUTS PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the T-Struts Project.
 */
import javax.servlet.http.*;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.*;
import jp.ossc.tstruts.action.ExtendActionMapping;
import jp.ossc.tstruts.config.ForwardValueConfig;

/**
 * 
 * @version $Name: release-1_1-1_0 $
 * @author H.Matsuno
 * @since 1.0
 */
public class AddAction extends org.apache.struts.action.Action {

	protected Log log = LogFactory.getLog(this.getClass());

	public ActionForward execute(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
		throws Exception {

		DynaActionForm addform = (DynaActionForm) form;
		int a = Integer.parseInt((String) addform.get("a"));
		int b = Integer.parseInt((String) addform.get("b"));
		int sum = a + b;
		addform.set("sum", Integer.toString(sum));

		request.setAttribute("test", addform);

		/* <select-forward>gĂꍇ */
		if (((ExtendActionMapping) mapping).getSelectForwardConfig() != null) {
			String result =
				(String) addform.get(
					((ExtendActionMapping) mapping)
						.getSelectForwardConfig()
						.getProperty());
			log.info(
				"Property is: "
					+ ((ExtendActionMapping) mapping)
						.getSelectForwardConfig()
						.getProperty());
			log.info("Result is: " + result);

			ForwardValueConfig config =
				((ExtendActionMapping) mapping)
					.getSelectForwardConfig()
					.findForwardValueConfig(
					result);
			log.info("Config is: " + config);

			log.info("forward name is: " + config.getName());
			if (config.getName() != null)
				return mapping.findForward(config.getName());
		}

		return mapping.findForward("success");
	}

}
